( -- start of the script
-- declare a function to determine if the pass-in value "val" is odd or even	
fn IsOdd val = 
	(
	if ((mod val 2) != 0.0) then
		true
	else
		false
	)
	
-- returns the larger of the 2 supplied parameters
fn biggest val1 val2 =
	(
	if val1 > val2 then
		val1
	else
		val2
	)

-- declare some local constants	
-- these cna be changed to suit your needs
local xCount = 30,  yCount = 30 -- how many columns and rows do we want
local rad = 10 -- the Radius of the intial hexagon we create
local baseObject -- variable to hold that initial hexagon
local maxRndOffset = 4 -- used for randomising the vertices. vertices moved between +/- this value
local col, row, yOffset, tmp, ourObject, vertnum, firstTime = true -- remaining variables we need
local blob, sphereRadius, extents, noiseMod	
	
for col = 1 to xCount do -- outer loop, from left to right, columns
	(
	if IsOdd col then -- the hexagons in odd columns are positioned (rad * 2) * the row number -1
		yOffset = 0
	else -- those in the even columns are offset from those in the odd columns by 1 * rad
		yOffset = rad
	
	for row = 1 to yCount do -- inner loop, from front to back, rows
		(
		if firstTime then -- first time we have got to this point
			(
			-- create the baseObject we'll be copying later
			-- circumscribed hehagon. radius is to the flat sides, inscribed would be to the points
			baseObject = nGon name:"Hex" \ -- constructors like this can only span lines
				nSides:6 radius:rad scribe:0 \ -- if you add a backslash at the end of each line
				position:[0, 0, 0] 
			convertToPoly baseObject -- converts the shape to an editable poly object
			) -- end of the if-then statement
		tmp = copy baseObject -- make a duplicate	
		yPos = ((row - 1) * rad * 2) + yOffset -- calculate the position where the new object needs to be located
		xPos = (col - 1) * 1.7321 * rad -- 1.7321 is the square root of 3, don't ask - I had to google it :o
		tmp.pos = [xPos, yPos, 0] -- set the position
		if firstTime then 
			(
			ourObject = tmp -- this is the beginning of our final object
			firstTime = false -- mustn't do this again
			)
		else
			polyop.attach ourObject tmp -- attach the new one to our final object
		) -- end of the inner (row) loop
	) -- end of the outer (col) loop
delete baseObject -- we don't need it any more
-- now to weld all those duplicated vertices
ourObject.weldThreshold = 0.1 -- make sure the weld threshold is low so we don't weld too much
polyop.weldVertsByThreshold ourObject #All -- #all is equivalent to creating a list (array) of all the vertices in the object
-- now to randomise the positions of all the vertices
for vertNum = 1 to (polyop.getNumVerts ourObject) do -- the "to" must evaluate to a single valuem hence the ( )
	(
	polyop.moveVert ourObject #(vertNum) \ -- vertex number as a list
		[random ((maxRndOffset * -1) as float) (maxRndOffset as float), \ 
		 random ((maxRndOffset * -1) as float) (maxRndOffset as float), \
		 0]
	) -- end of the for loop

centerPivot ourObject -- affect pivot only + center to object
extents = nodeLocalBoundingBox ourObject -- min/max x/y
if extents[1].x < 0.0 then
	sizeX = extents[2].x + abs extents[1].x
else
	sizeX = extents[2].x - extents[1].x
if extents[1].y < 0.0 then
	sizeY = extents[2].y + abs extents[1].y
else
	sizeY = extents[2].y - extents[1].y
sphereRadius = biggest sizeX sizeY
-- create our blob
sphereRadius = sphereRadius * 0.75 -- make the sphere big enough, hopefully
blob = sphere name:"ourBlob" radius:sphereRadius segs:100 smooth:true \
	pos:[ourObject.pos.x, ourObject.pos.y, (sphereRadius * 2 * -1)]
--create a noise modifier
noiseMod = noiseModifier scale:100 seed:7 fractal:true iterations:2.0 strength:[100,100,100]
addModifier blob noiseMod

) -- end of the script
